﻿#L. Beauguitte, http://groupefmr.hypotheses.org/
#L'analyse de réseaux avec R, les premiers pas (deuxième partie)

rm(list=ls())

l <- read.table("liens.txt", sep=";", header=TRUE)
s <- read.table("sommets.txt", sep=";", header=TRUE,stringsAsFactors=FALSE) 

#avec statnet

library(statnet)
ls <- as.network(as.matrix(l[,c(1:2)]), directed=FALSE)
ls
gplot(ls)

#attributs pour les sommets (v comme vertex, e comme edge)

ls %v% "GENRE" <- s$GENRE  
ls %v% "AGE" <- s$AGE
ls %e% "int" <- l$INT

#couleur en fonction genre
#taille selon âge
#épaisseur des liens vers intensité

nodeColors<-ifelse(s$GENRE == "F","Pink","Blue")

gplot(ls, gmode="graph", displaylabels=TRUE, vertex.col=nodeColors,
      vertex.cex= s$AGE/4, edge.lwd = l$INT)

detach(package:statnet)

#avec  igraph
library(igraph)

g <- graph.data.frame(l, directed=FALSE, vertices = s)
g

vertexCol <- get.vertex.attribute(g,"GENRE")
colors = c("Pink","Blue")
vertexCol[vertexCol == "F"] = colors[1]
vertexCol[vertexCol == "M"] = colors[2]

vertexSiz <- get.vertex.attribute(g, "AGE")

edgeW <- get.edge.attribute(g, "INT")

plot(g, vertex.color= vertexCol, vertex.size = vertexSiz, 
      edge.width = edgeW)